
;				 Horloge JC "Les Potiers" Toulouzze


; Affichage : Heures, minutes, la secondes clignote, c'est joli !
; Rglages : Raz des secondes, Rglage des Heures, des Minutes, Reset
; Interruption provoque par le timer 'temps rel'
; Comptages des inters Quartz 4096KHz (Fe=1024kHz)
; Prdiviseur par 32 
; Le dbordement du timer provoque une interruption toutes les 8ms
; Il faut 125 interruptions pour faire une seconde
	
;*************************************************************************
			
;Configuration du pic, des registres et appel des macros		
			config cp=non, pwrt=non, wdt=non, osc=xt
			include "registres.h" 	;Les constantes registres
			include "stdmac.h"	;Les macros

;Dfinition des constantes			
CTinter		equ d'125'	;Cte du Nb d'inter pour la seconde(1=8ms)
CTreglage		equ d'40'	;Cte de la frquence de comptage du rglage

Max60		equ d'60'	;Cte valeur max de comptage modulo 60
Max24		equ d'24'	;Cte valeur max de comptage modolo 24
MaxUnite		equ d'10'	;Cte valeur max Units de conversion Bin/Bcd

Aff1		equ h'10'	;Cte RB4 commande de l'aff1.(le +  droite)
Aff2		equ h'20'	;Cte RB5 commande de l'afficheur 2
Aff3		equ h'40'	;Cte RB6 commande de l'afficheur 3 
Aff4		equ h'80'	;Cte RB7 commande de l'aff4.(le +  gauche)

ToucheRA0		equ d'0'	;Cte bit RA0, Raz des secondes (le +  gauche)
ToucheRA1		equ d'1'	;Cte bit RA1, rglage des minutes
ToucheRA2		equ d'2'	;Cte bit RA2, rglage des heures
ToucheRA3		equ d'3'	;Cte bit RA3, Reset (le +  droite)

SortieRA4		equ d'4'	;Cte bit RA4(PORTA)

;Rservaton des variables	
			org	0x20,zreg ;zone registre libre (usage gnral)

NBinter		rm	1	;Var. Comptage des interruptions du timer
NbTempoReg	rm	1	;Var. pour la tempoReg

Secondes		rm	1	;Var. compteur des secondes
Minutes		rm	1	;Var. compteur des minutes
Heures		rm	1	;Var. compteur des heures

DataAff12		rm	1	;Var. octet  convertir pour les aff. 1 et 2
DataAff34		rm	1	;Var. octet  convertir pour les aff. 3 et 4

Aff1Data		rm	1	;Var. 4 bits pour l'afficheur 1 (le +  droite)
Aff2Data		rm	1	;Var. 4 bits pour l'afficheur 2 
Aff3Data		rm	1	;Var. 4 bits pour l'afficheur 3  
Aff4Data		rm	1	;Var. 4 bits pour l'afficheur 4 (le +  gauche)

Bin			rm    1	;Var. octet  convertir en BCD 
BcdUnite		rm	1	;Var. unite BCD convertie  
BcdDizaine	rm	1	;Var. dizaine BCD convertie  

;-------------------Dbut du programme aprs reset------------------------		
			org	0,zprog	;Reset toujours  l'adresse 0
			goto  Init
				
;----------------------Programme d'interruption---------------------------
			org	4,zprog	;Inter toujours  l'adresse 4
			
			decfsz NBinter	;Dcrmente  chaque inter pour seconde
			goto 	Suite		;Si NBinter pas 0 alors suite
			call	Compteur	;Si NBinter=0 alors on compte
						
			movlf	CTinter,NBinter	;Initialisation du compteur CTinter		
		
Suite		bcf	INTCON,T0IF		;Drapeau d'inter  0
			retfie 			;Retour au programme principal

;Compteur Secondes,Minutes,Heures.
Compteur		incf	Secondes				;Secondes=Secondes+1
			beqc	Secondes,Max60,RazSecondes	;Si Secondes=Max60
			return		;alors on va  RazSecondes sinon retour
									
RazSecondes	clrf	Secondes				;Raz Secondes
RegMin		incf	Minutes				;Minutes=Minutes+1
			beqc	Minutes,Max60,RazMinutes	;Si Minutes=Max60
			return		;alors on va  RazMinutes sinon retour
							
RazMinutes	clrf	Minutes		 		;Raz Minutes
RegHeur		incf	Heures		 		;Heures=Heures+1
			beqc	Heures,Max24,RazHeures		;Si Heures=Max24
			return		;alors on va  RazHeures sinon retour
			
RazHeures		clrf	Heures	;Il est minuit con !	 
			return					

;-------------------Programme principal-----------------------------------
;initialisations
Init		bsf	STATUS,RP0	;passer en page 1 (accs  TRIS et OPTION)

			clrf	TRISB			;Tout PORTB en sortie, 
			bcf	TRISA,SortieRA4	;RA4 en sortie, le reste en entre
			movlw	(1<<RBPU)|(0<<PS0)|(0<<PS1)|(1<<PS2) ;pas de pull Up
			movwf	OPTIO	    		;sur port B et timer prdiv/32
			
			bcf	STATUS,RP0		;Repasser en page 0
			
			movlw	(1<<T0IE)|(1<<GIE);Validation locale et globale  
			movwf	INTCON 		;pour autoriser l'inter timer
			movlf	CTinter,NBinter	;Init du dcompte des inters	
			clrf	Secondes		;Raz des variables
			clrf	Minutes
			clrf	Heures

;Boucle du programme principal
Boucle		call DetecteTouches	;Dtection touches clavier

;Chargement des Donnes  afficher
			movff Minutes,DataAff12	;Chargement des donnes
			movff Heures,DataAff34	; afficher
			call	ConvertAff		;Conversion Bin/Bcd
			
;Affichage multiplex
			call	Affiche		;Affichage multiplex
			call	ClignoSortie	;La sortie clignote  la seconde
			goto	Boucle         	;On reboucle
			
;-----------------------Sous programmes-----------------------------------
;Traitement des valeurs  afficher : conversion et stockage
ConvertAff	movff	DataAff12,Bin	;On charge la valeur  convertir	
			call	BinBcd		;Conversion Binaire/Bcd
			movff	BcdUnite,Aff1Data	  ;Envoi des valeurs Bcd dans les
			movff	BcdDizaine,Aff2Data ;registres d'affichage
			
			movff	DataAff34,Bin	;Pareil que pour les secondes
			call	BinBcd
			movff	BcdUnite,Aff3Data
			movff	BcdDizaine,Aff4Data
			return

;Conversion Binaire/BCD dynamique (max = 99, 2 chiffres)
BinBcd		clrf	BcdUnite		;Raz de la variable Unite 
			clrf	BcdDizaine		;Raz de la variable Dizaine
			
Bcl			movf	Bin,W			
			skipz				;Si Bin = 0, on retourne
			goto	IncBcdUnite		;Sinon IncBcdUnite
			return		

IncBcdUnite	incf	BcdUnite		;BcdUnite = BcdUnite+1
			decf	Bin			;On dcrmente Bin		
			beqc	BcdUnite,MaxUnite,RazBcdUnite	;Si BcdUnite=MaxUnite
			goto	Bcl			;on va  RazBcdUnite, sinon Bcl
									
RazBcdUnite	clrf	BcdUnite		;Raz 	BcdUnite
			incf	BcdDizaine		;BcdDizaine = BcdDizaine+1	
			goto	Bcl

;Affichage multiplex
Affiche		movf	Aff1Data,W		;On charge la donne quartet bas
			iorlw	Aff1			;On charge l'afficheur quartet haut
			movwf	PORTB			;On envoie PORTB
			call	T1mS			;On temporise		
		
			movf	Aff2Data,W		;Pareil...
			iorlw	Aff2			
			movwf	PORTB			
			call	T1mS		

			movf	Aff3Data,W		;Pareil...
			iorlw	Aff3		
			movwf	PORTB			
			call	T1mS	
			
			movf	Aff4Data,W		;Pareil...
			iorlw	Aff4		
			movwf	PORTB			
			call	T1mS	

TempoRgl		movf	NbTempoReg		;Tempo pour les rglages
			skipz			;On rpte CTreglage fois l'affichage
			goto decreme		; et du coup, a ralentit !
			return

decreme		decf	NbTempoReg		
			goto Affiche

;Clignotement de la Sortie RA4  la seconde (F = 1Hz)
ClignoSortie	movf	Secondes,W		;Seconde dans W
			andlw	1			;On ne garde que le bit 0
			bz	ClrRA4		;Si 0 alors SortieRA4=0
			goto	SetRA4		;Sinon SortieRA4=1 et voila !
			
ClrRA4		bcf	PORTA,SortieRA4	;Sortie=1
			return

SetRA4		bsf	PORTA,SortieRA4	;Sortie=0
			return

;Dtection des touches
DetecteTouches	btfss	PORTA,ToucheRA0	;Raz des Secondes ou suite
			call	RazSec		
						
			btfss	PORTA,ToucheRA1   ;Rglage minute ou suite
			call	RegHeures			
			
			btfss	PORTA,ToucheRA2	;Rglage heure ou suite
			call	RegMinutes		
		
			btfss	PORTA,ToucheRA3	;Reset ou return
			call	Init					
		
			return

;Rglage de l'horloge
RazSec		clrf	Secondes
			return
			
RegMinutes	movlf	CTreglage,NbTempoReg ;Init. de la tempo de reglage
			call	RegMin		   ;Rglage des minutes
			return

RegHeures		movlf	CTreglage,NbTempoReg ;Init. de la tempo de reglage
			call	RegHeur		   ;Rglage des heures
			return

;Temporisation logicielle pour le multiplexage			

			include "Tempo4.inc"	;Fichier des Tempo 


;-----------------------------Fin------------------------------------------		
			end				;Fin du programme
			
